<?php
class kTemplate extends kBase
{
var $paths = array();
var $vars = array();
var $conditions = array();
var $conditionals = array();
var $content;
var $nodes = array();
var $blocks = array();
var $layout = false;
var $auto_parse = 1;
var $parse_widgets = true;
var $recursive_paths = 0;
var $strip_comments = 0;
var $strip_whitespace = 0;
var $tag_block_begin = 'BEGIN BLOCK:';
var $tag_block_end = 'END BLOCK:';
var $tag_condition_begin = 'BEGIN CONDITION:';
var $tag_condition_end = 'END CONDITION:';
var $pathnames = array();
var $REGEX_EMBED = '/(<!--\s*BEGIN\s+DBLOCK:\s*([A-Za-z][-_A-Za-z0-9.]+)(\s*|\s+.*?)-->)/';
var $REGEX_DYNBEG = '/(<!--\s*BEGIN\s+DBLOCK:\s*([A-Za-z][-_A-Za-z0-9.]+)(\s*|\s+.*?)-->)/';
var $REGEX_DYNEND = '/(<!--\s*END\s+DBLOCK:\s*([A-Za-z][-_A-Za-z0-9.]+)(\s*|\s+.*?)-->)/';
var $REGEX_VAR = '/\{[A-Za-z][-_A-Za-z0-9]*\}/';
function kTemplate()
{
$this->nodes = array();
$this->nodes[0]['parent'] = -1;
}
function add_path($path)
{
if(is_dir($path))
{
$this->paths[] = $this->get_file_tree($path,'tpl');
return true;
}
else
{
return false;
}
}
function assign($var_name,$value)
{
if(isset($value))
{
$this->vars[$var_name] = $value;
}
}
function assign_array($array,$stripslashes = 0)
{
foreach($array as $key=>$value)
{
if(!is_array($value))
{
$this->assign($key,($stripslashes == 1) ?stripslashes($value) : $value);
}
}
}
function assign_array_d($blockname,$array,$stripslashes = 0)
{
foreach($array as $key=>$value)
{
if(isset($value))
{
$this->blocks[$blockname]['vars_c'][$key] = ($stripslashes == 1) ?stripslashes($value) : $value;
}
}
}
function assign_d($blockname,$var_name,$value)
{
if(isset($value))
{
$this->blocks[$blockname]['vars_c'][$var_name] = $value;
}
}
function create_node($parent_id,$blockname,$fields = '')
{
$node_max = sizeof($this->nodes) >1 ?sizeof($this->nodes) : 1;
$this->nodes[$node_max]['parent'] = $parent_id;
$this->nodes[$node_max]['blockname'] = $blockname;
$this->nodes[$node_max]['fields'] = $fields;
return true;
}
function define($blockname,$input,$is_string = 0)
{
if($is_string)
{
if(!empty($input))
{
$this->blocks[$blockname]['content'] = $input;
}
else
{
return false;
}
}
else
{
$this->blocks[$blockname]['filename'] = $input;
$this->blocks[$blockname]['content'] = $this->read_file($input);
}
if(isset($this->blocks[$blockname]['content']))
{
$this->blocks[$blockname]['active'] = true;
$this->blocks[$blockname]['parent'] = "_TOP";
return true;
}
else
{
$this->errors[] = 'Error loading template block: '.$blockname;
return false;
}
}
function define_d($blockname,$parent)
{
if(isset($this->blocks[$parent]['active']))
{
$this->blocks[$blockname]['parent'] = $parent;
$str_begin_b = "<!-- ".$this->tag_block_begin ." ".$blockname ." -->";
$str_end_b = "<!-- ".$this->tag_block_end ." ".$blockname ." -->";
$str_content_b = $this->str_extract($this->blocks[$parent]['content'],$str_begin_b,$str_end_b);
if(isset($str_content_b))
{
$this->blocks[$blockname]['content'] = $str_content_b;
$regex = '/(<!--\s*BEGIN\s+BLOCK:\s*'.$blockname .
' -->[^?]*<!--\s*END\s+BLOCK:\s*'.$blockname .' -->)/';
$this->blocks[$parent]['content'] = 
preg_replace($regex,'<!-- BLOCK: '.$blockname .' -->',str_replace('?','&#63;',$this->blocks[$parent]['content']));
$this->blocks[$blockname]['active'] = true;
return true;
}
else
{
unset($this->blocks[$blockname]);
$this->errors[] = "Error in define_d, couldn't fetch dynamic block contents";
return false;
}
return true;
}
else
{
$this->errors[] = "Error in define_d, parent block not defined or inactive";
return false;
}
}
function get_file_list($path)
{
$d = dir($path);
while (false !== ($entry = $d->read())) {
if(substr($entry,0,1) != '.') $templates[] = $entry;
}
$d->close();
return $templates;
}
function get_file_tree($path,$ext = 0)
{
if(empty($list)) $list = array();
$handle = opendir($path);
while($a = readdir($handle))
{
if(!preg_match('/^\./',$a))
{
$full_path = $path .$a .'/';
if(($ext !== 0) &&(preg_match('/\.'.$ext .'$/',$a)))
{
$list[$a] = $path;
}
if((is_dir($full_path)) &&(!preg_match('/(\/.+){20,}/',$full_path)) &&($this->recursive_paths == 1))
{
$recursive = $this->get_file_tree($full_path,$ext);
foreach($recursive as $key=>$value) {
$list[$key] = $value;
}
}
}
}
closedir($handle);
return $list;
}
function get_last_block_node($blockname)
{
$node_max = sizeof($this->nodes) == 0 ?0 : sizeof($this->nodes)-1;
for($i=$node_max;$i>=0;$i--)
{
if(isset($this->nodes[$i]['blockname']) &&$this->nodes[$i]['blockname'] == $blockname) return $i;
}
return false;
}
function inject($blockname,$target)
{
if($parent_id = $this->get_last_block_node($this->blocks[$target]['parent']))
{
$this->create_node($parent_id,$blockname,$this->blocks[$blockname]['vars_c']);
unset($this->blocks[$blockname]['vars_c']);
return true;
}
else
{
$this->errors[] = 'No matching node found for "'.$blockname .'" in $template->get_last_block_node()';
return false;
}
}
function is_set($var)
{
if((array_key_exists($var,$this->vars)) &&(!empty($this->vars[$var])))
{
return true;
}
else
{
return false;
}
}
function parse($blockname)
{
if($this->create_node(0,$blockname))
{
if(strpos($this->blocks[$blockname]['content'],'<!-- '.$this->tag_condition_begin))
{
if($str_content_title = $this->str_extract($this->blocks[$blockname]['content'],'<!-- '.$this->tag_condition_begin .' ',' -->'))
{
$str_begin_b = "<!-- ".$this->tag_condition_begin ." ".$str_content_title ." -->";
$str_end_b = "<!-- ".$this->tag_condition_end ." ".$str_content_title ." -->";
$str_content_b = $this->str_extract($this->blocks[$blockname]['content'],$str_begin_b,$str_end_b);
if(isset($str_content_b))
{
if(isset($this->conditionals[$str_content_title]))
{
$index_b = sizeof($this->conditionals[$str_content_title]);
}
else 
{
$index_b = 0;
}
$str_block_title = $str_content_title .$index_b;
$this->conditionals[$str_content_title][$index_b] = $str_block_title;
$regex = '/(<!--\s*BEGIN\s+CONDITION:\s*'.$str_content_title .
' -->[^?]*<!--\s*END\s+CONDITION:\s*'.$str_content_title .' -->)/';
$this->blocks[$blockname]['content'] = 
preg_replace($regex,'<!-- BLOCK: '.$str_block_title .' -->',str_replace('?','&#63;',$this->blocks[$blockname]['content']));
$this->blocks[$str_block_title]['active'] = true;
$this->blocks[$str_block_title]['content'] = $str_content_b;
$this->blocks[$str_block_title]['parent'] = $blockname;
return true;
}
}
else
{
unset($this->blocks[$blockname]);
$this->errors[] = "Error in define_d, couldn't fetch dynamic block contents";
return false;
}
}
return true;
}
else 
{
return false;
}
}
function parse_d($blockname) {
if(!$this->blocks[$blockname]['parent']) die('$template::parse_d ( '.$blockname .' )');
if($parent_id = $this->get_last_block_node($this->blocks[$blockname]['parent']))
{
if(!isset($this->blocks[$blockname]['vars_c']))
{
$this->blocks[$blockname]['vars_c'] = '';
}
$this->create_node($parent_id,$blockname,$this->blocks[$blockname]['vars_c']);
unset($this->blocks[$blockname]['vars_c']);
return true;
}
else 
{
die('Error seeking last block node in template::parse_d ( '.$blockname .' )');
}
}
function read_file($filename) {
if(isset($this->paths))
{
reset($this->paths);
foreach($this->paths as $k=>$v)
{
if(!empty($this->paths[$k][$filename]))
{
$filename = $this->paths[$k][$filename] .$filename;
if(file_exists($filename))
{
$fhandle = fopen($filename,"r");
if(filesize($filename) >0)
$fcontent = fread ($fhandle,filesize($filename));
fclose($fhandle);
return $fcontent;
}
}
}
}
}
function render_all($return = 0)
{
foreach($this->conditionals as $key=>$value)
{
if((!empty($this->conditions[$key])) &&($this->conditions[$key] === 1))
{
if((is_array($this->conditionals[$key])))
{
foreach($this->conditionals[$key] as $k=>$v)
{
$this->parse_d($v);
}
}
}
}
$this->contents = '';
$this->render_node(0);
$c_len = strlen($this->contents);
$tagstart = '<!-- NOPARSE -->';
$tagend = '<!-- END NOPARSE -->';
$index = $pos = 0;
$startlen = strlen($tagstart);
$endlen = strlen($tagend);
while($startpos = strpos($this->contents,$tagstart,$pos))
{
if($endpos = strpos($this->contents,$tagend,$startpos))
{
$noparse[$index] = substr($this->contents,$startpos,($endpos -$startpos +$endlen));
$this->contents = substr($this->contents,0,$startpos) .
'<!-- PARSER'.$index .' -->'.
substr($this->contents,($endpos +$endlen));
$index++;
if($index >500) break;
}
else
{
break;
}
}
foreach($this->vars as $varname=>$value)
{
$this->contents = preg_replace("'\{".$varname."\}'si",str_replace("$","\\$",$value),$this->contents);
}
if($this->parse_widgets)
{
$widget_reg = '/\{([A-Za-z0-9].*?)\(([^\}].*?)?\)\}/';
preg_match_all($widget_reg,$this->contents,$matches_r);
if((!empty($matches_r[0][0])) &&(!empty($matches_r[1][0])))
{
for($i=0;$i<count($matches_r[1]);$i++)
{
$widget_name = $widget_paramstr = '';
$widget_params = array();
if(!empty($matches_r[1][$i]))
{
$widget_name = $matches_r[1][$i];
if(!empty($matches_r[2][$i]))
{
$widget_paramstr = $matches_r[2][$i];
$widget_params = k_explode_paramstr(',',$widget_paramstr);
foreach($widget_params as $key =>$value)
{
if($value == 'false') $widget_params[$key] = false;
if($value == 'true') $widget_params[$key] = true;
}
}
$widget_html = (function_exists('widget_'.$widget_name)) ?widgetLoad($widget_name,$widget_params) : '';
$this->contents = str_replace('{'.$widget_name .'('.$widget_paramstr .')}',$widget_html,$this->contents);
}
}
}
}
foreach($this->vars as $varname=>$value)
{
$this->contents = preg_replace("'\{".$varname."\}'si",str_replace("$","\\$",$value),$this->contents);
}
if($this->auto_parse === 1)
{
$this->contents = preg_replace('/({)[A-Za-z0-9_]*(})/e','',$this->contents);
}
if((!empty($noparse)) &&(is_array($noparse)))
{
foreach($noparse as $key =>$value)
{
$this->contents = str_replace('<!-- PARSER'.$key .' -->',$value,$this->contents);
}
}
if($this->strip_comments === 1)
{
$this->contents = preg_replace('/(<!--)(.*)(-->)/e','',$this->contents);
}
if($this->strip_whitespace === 1)
{
$this->contents = str_replace("\n"," ",$this->contents);
$this->contents = eregi_replace(" +"," ",$this->contents);
}
$this->contents = str_replace('&#63;','?',$this->contents);
if($return)
{
return trim($this->contents);
}
else 
{
echo trim($this->contents);
}
}
function render_node($node_id) {
if($this->nodes[$node_id]['parent'] == 0) 
{
if(!empty($this->blocks[$this->nodes[$node_id]['blockname']]['content']))
{
$content_r = $this->blocks[$this->nodes[$node_id]['blockname']]['content'];
$this->contents .= $content_r;
}
else 
{
$this->contents = ' ';
}
}
else
{
if(isset($this->nodes[$node_id]['blockname']))
{
$content_r = $this->blocks[$this->nodes[$node_id]['blockname']]['content'];
if(is_array($this->nodes[$node_id]['fields']))
{
foreach($this->nodes[$node_id]['fields'] as $index_c=>$value_c)
{
if(!is_array($value_c))
{
$content_r = preg_replace('/\{'.$index_c.'\}/',str_replace("$","\\$",$value_c),$content_r);
}
}
}
$str_block_tag = "<!-- BLOCK: ".$this->nodes[$node_id]['blockname'] ." -->";
$lastpos = $this->strrpos_mb($this->contents,$str_block_tag);
$this->contents = substr_replace($this->contents,$content_r.$str_block_tag,$lastpos,strlen($str_block_tag));
}
}
$node_max = sizeof($this->nodes);
for($index=1;$index <$node_max;$index++)
{
if($this->nodes[$index]['parent'] == $node_id)
{
$this->render_node($index);
}
}
return true;
}
function replace_var($search,$replace,$string)
{
return preg_replace("'\{".$search."\}'si",str_replace("$","\\$",$replace),$string);
}
function set_condition($name,$value = 0)
{
$this->conditions[$name] = $value;
}
function str_extract($string,$sep1,$sep2) {
$string = substr($string,0,strpos($string,$sep2));
$string = substr(strstr($string,$sep1),0);
$string = str_replace($sep1,"",$string);
return $string;
}
function strrpos_mb($haystack,$needle)
{
$offset = 0;
$pos_rule = ($offset<0)?strlen($haystack)+($offset-1):$offset;
$last_pos = false;$first_run = true;
do {
$pos=strpos($haystack,$needle,(intval($last_pos)+(($first_run)?0:strlen($needle))));
if ($pos!==false &&(($offset<0 &&$pos <= $pos_rule)||$offset >= 0)) {
$last_pos = $pos;
}else {break;}
$first_run = false;
}while ($pos !== false);
if ($offset>0 &&$last_pos<$pos_rule) {$last_pos = false;}
return $last_pos;
}
}


?>