<?php
class kValidate extends kBase
{
function kValidate()
{
$this->friendly_text = '(^[-A-Za-z0-9 ]*$)';
$this->friendly_url = '(^[-A-Za-z0-9]*$)';
$this->errorlist = array();
}
function is_valid($string,$min_length,$max_length,$regex)
{
$str = trim($string);
if(empty($str))
{
return false;
}
if(!eregi("^$regex$",$string))
{
return false;
}
$strlen = strlen($string);
if(($min_length != 0 &&$strlen <$min_length) ||($max_length != 0 &&$strlen >$max_length))
{
return false;
}
return true;
}
function is_alpha($string,$min_length = 0,$max_length = 0) 
{
$return = $this->is_valid($string,$min_length,$max_length,"[[:alpha:]]+");
return($return);
}
function is_number($string,$min_length = 0,$max_length = 0)
{
$return = $this->is_valid($string,$min_length,$max_length,"[[:digit:]]+");
return($return);
}
function is_alphanumeric($string,$min_length = 0,$max_length = 0)
{
$return = $this->is_valid($string,$min_length,$max_length,"[[:alnum:]]+");
return($return);
}
function is_clean_text($string,$min_length = 0,$max_length = 0)
{
$return = $this->is_valid($string,$min_length,$max_length,"[a-zA-Z0-9[:space:].`# '-]+");
return($return);
}
function is_written_text($string,$min_length = 0,$max_length = 0) 
{
$return = $this->is_valid($string,$min_length,$max_length,"[a-zA-Z0-9[:space:].,`# '-]+");
return($return);
}
function is_username($value,$min_length=3,$max_length=16)
{
if(preg_match("!^[a-z0-9_]{".$min_length.",".$max_length."}$!i",$value))
{
return true;
}
else
{
$this->errors[] = 'Invalid username';
return false;
}
}
function is_location($value,$min_length=5,$max_length=16)
{
if(preg_match("!^[-_, a-z0-9]{".$min_length.",".$max_length."}$!i",$value))
{
return true;
}
else
{
return false;
}
}
function is_password($value,$msg="",$min_length=4,$max_length=16) 
{
if(eregi("[^a-z0-9]",$value) ||strlen($value) <$min_length ||strlen($value) >$max_length) 
{
$addinfo="";
$this->errorlist[] = array("value"=>$value,"msg"=>$msg,"addinfo"=>$addinfo);
return false;
}
return true;
}
function is_email($string) 
{
$string = trim($string);
$result = ereg('^([A-Za-z0-9_!]|\\-|\\.)+'.
'@'.
'(([A-Za-z0-9_]|\\-)+\\.)+'.
'[A-Za-z]{2,4}$',$string);
return($result);
}
function is_url($urladdr)
{
$regexp = "^(https?://)";
$regexp .= "?(([0-9a-z_!~*'().&=+$%-]+:)?[0-9a-z_!~*'().&=+$%-]+@)?";
$regexp .= "(([0-9]{1,3}\.){3}[0-9]{1,3}";
$regexp .= "|";
$regexp .= "([0-9a-z_!~*'()-]+\.)*";
$regexp .= "([0-9a-z][0-9a-z-]{0,61})?[0-9a-z]\.";
$regexp .= "[a-z]{2,6})";
$regexp .= "(:[0-9]{1,4})?";
$regexp .= "((/?)|";
$regexp .= "(/[0-9a-z_!~*'().;?:@&=+$,%#-]+)+/?)$";
if (eregi( $regexp,$urladdr ))
{
if (!eregi( "^https?://",$urladdr )) $urladdr = "http://".$urladdr;
if (!eregi( "^https?://.+/",$urladdr )) $urladdr .= "/";
if ((eregi( "/[0-9a-z~_-]+$",$urladdr)) &&(!eregi( "[\?;&=+\$,#]",$urladdr))) $urladdr .= "/";
return ($urladdr);
}
else 
return false;
}
function contains_bad_words($string)
{
$bad_words = array('cunt','dildo','fuck');
for($i=0;$i<count($bad_words);$i++)
{
if(strstr(strtoupper($string),strtoupper($bad_words[$i])))
{
return true;
}
}
return false;
}
function is_numeric_big($string=0) 
{
return preg_match('/^-?\d+$/',$string);
}
function is_zip_code($string = "")
{
return $this->is_valid($string,0,0,'^[0-9]{5}([-]{1}[0-9]{4})?$');
}
function is_currency($string,$dollar_sign=0)
{
if($dollar_sign)
$patt = '/^\s*[$]?\s*((\d+)|(\d{1,3}(\,\d{3})+))(\.\d{2})?\s*$/';
else 
$patt = '/^\s*((\d+)|(\d{1,3}(\,\d{3})+))(\.\d{2})?\s*$/';
if(!preg_match($patt,$string,$matches))
return false;
return true;
}
function is_phone_number($string,$msg="")
{
if(empty($string))
{
$addinfo = "No Phone Number submitted";
$this->errorlist[] = array("value"=>$string,"msg"=>$msg,"addinfo"=>$addinfo);
return false;
}
$num = $string;
$num = ereg_replace("([ ]+)","",$num);
$num = eregi_replace("(\(|\)|\-|\+|\/|\.|\x|\ext)","",$num);
if(!$this->is_numeric_big($num))
{
$bad_chars = eregi_replace("[0-9]","",$num);
$addinfo = "Bad characters in Phone number: (\"".$bad_chars."\").";
$this->errorlist[] = array("value"=>$string,"msg"=>$msg,"addinfo"=>$addinfo);
return false;
}
if ( (strlen($num)) <7)
{
$addinfo = "Phone number is too short.";
$this->errorlist[] = array("value"=>$string,"msg"=>$msg,"addinfo"=>$addinfo);
return false;
}
if( (strlen($num)) >13)
{
$addinfo = "Phone number is too long.";
$this->errorlist[] = array("value"=>$string,"msg"=>$msg,"addinfo"=>$addinfo);
return false;
}
return true;
}
function is_real_name($string,$min_length=0,$max_length=0)
{
return $this->is_clean_text($string,$min_length,$max_length);
}
function is_cc_type($cc_type,$msg="")
{
switch(strtoupper($cc_type))
{
case "MC":
case "VISA":
case "AMEX":
case "DISC":
return true;
break;
default:
$addinfo = "Credit Card Type is invalid";
$this->errorlist[] = array("value"=>$string,"msg"=>$msg,"addinfo"=>$addinfo);
return false;
break;
}
}
function is_db_fieldname($string)
{
if(preg_match("/^[A-Za-z0-9]/",$string))
{
return true;
}
else
{
$this->errors[] = 'Invalid MySQL field name';
return false;
}
}
function is_title($string,$min_length = 0,$max_length = 0)
{
$return = $this->is_valid($string,$min_length,$max_length,"[a-zA-Z0-9[:space:].`$&# '-]+");
return($return);
}
function is_desc($string,$min_length = 0,$max_length = 0)
{
$return = $this->is_valid($string,$min_length,$max_length,"[a-zA-Z0-9[:space:].`,$&# '-]+");
return($return);
}
function is_cc_num($cc_num,$cc_type)
{
$num = ereg_replace("[^0-9]","",$cc_num);
switch(strtoupper($cc_type))
{
case "MASTERCARD":
$cc_regex = "^5[1-5][0-9]{14}$";
break;
case "VISA":
$cc_regex = "^4[0-9]{12}$|^4[0-9]{15}$";
break;
case "AMEX":
$cc_regex = "^3[4|7][0-9]{13}$";
break;
case "BANKCARD":
$cc_regex = "^56[0-9]{14}$";
break;
default:
return false;
break;
}
if(!$this->is_valid($num,0,0,$cc_regex))
{
return false;
}
else 
{
$cc_c = strrev($num);
$numSum = 0;
for($i = 0;$i <strlen($cc_c);$i++)
{
$c_num = substr($cc_c,$i,1);
if($i %2 == 1)
{
$c_num *= 2;
}
if($c_num >9)
{
$firstNum = $c_num %10;
$secondNum = ($c_num -$firstNum) / 10;
$c_num = $firstNum +$secondNum;
}
$numSum += $c_num;
}
$pass = ($numSum %10 == 0);
if($pass)
{
return true;
}
else
{
return false;
}
}
}
}


?>